import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot and MouseInfo)

/**
 * Write a description of class Punt here.
 * 
 * @author (your name) 
 * @version (a version number or a date)
 */
public class Punt extends Actor
{
    
    private int dx = 1, dy = 0;
    private int points = 0;
    private GreenfootImage[] images = new GreenfootImage[4];
    //private int direction;
    private int dotsTouched;
    private int badDotsTouched;
    private int punt;
    static private boolean alive;

    public void Punt(){
        for (int i=0; i<4; i++)
        {
            images[i] = new GreenfootImage("puntmanSprite1.png");
            images[i].mirrorHorizontally();
        }
        setImage(images[1]);
    }
    @Override
    public void move(final int distance) {
        super.move(distance);
        if (isTouching(Collider.class)) {
            super.move(-distance);
        }
        if (isTouching(Collider2.class)) {
            super.move(-distance);
        }
        if (isTouching(Collider3.class)) {
            super.move(-distance);
        }
        if (isTouching(Collider4.class)) {
            super.move(-distance);
        }
    }
    private void controls()
    {
        boolean press1 = false;
        if (Greenfoot.isKeyDown("up") && press1 == false) {
            setRotation(270);
            press1 = true;
            move(1);
        }
        if (!Greenfoot.isKeyDown("up")) { press1 = false; }
        
        boolean press2 = false;
        if (Greenfoot.isKeyDown("down") && press2 == false){
            setRotation(90);
            press2 = true;
            move(1);
        }
        if (!Greenfoot.isKeyDown("down")) { press2 = false; }
        
        boolean press3 = false;
        if (Greenfoot.isKeyDown("right") && press3 == false){
            setRotation(0);
            press3 = true;
            move(1);
        }
        if (!Greenfoot.isKeyDown("right")) { press3 = false; }
        
        boolean press4 = false;
        if (Greenfoot.isKeyDown("left") && press4 == false){
            setRotation(180);
            press4 = true;
            move(1);
        }
        if (!Greenfoot.isKeyDown("left")) { press4 = false; }
    } 

    public void act()
    {
        if(dotsTouched()) {
            eatDots();
            move(1);
        }
            controls();
            hitBadDot();
        if(badDotsTouched()){
            eatBadDots();
            move(1);
        }
        }
    public void hitBadDot(){
        if(isTouching(BadDot.class)) {
            getWorld().addObject(new YouLose(), 38, 23);
            getWorld().removeObject(this);
            Greenfoot.stop();
        }

    }
    /**
     * check if dot is in same cell as you 
     */
    public boolean dotsTouched()
    {
        Actor dots = getOneObjectAtOffset(0, 0, Dot.class);
        if(dots != null) {
            return true;
        }
        else {
            return false;
        }
    }
    /**
     * Eat dots.
     */
    public void eatDots()
    {
        Actor dots = getOneObjectAtOffset(0, 0, Dot.class);
        if(dots != null) {
            // eat the dot...
            getWorld().removeObject(dots);
            dotsTouched = dotsTouched + 1; 
        }
    }    
    /**
     * Eat bad dots before lose screen pops up.
     */
    
    public void eatBadDots()
    {
        Actor badDots = getOneObjectAtOffset(0, 0, BadDot.class);
        if(badDots != null) {
            // eat the dot...
            getWorld().removeObject(badDots);
            badDotsTouched = badDotsTouched + 1; 
        }
    }
    public boolean badDotsTouched()
    {
        Actor badDots = getOneObjectAtOffset(0, 0, BadDot.class);
        if(badDots != null) {
            return true;
        }
        else {
            return false;
        }
    }
    /**
     * Eat dots.
     */
    public int getBadDotsTouched()
    {
        return badDotsTouched;
    
    }
    public int getDotsTouched()
    {
        return dotsTouched;
    }
    }
  